﻿#----------------------------------------------------
#■多角形辺近傍法による巡回セールスマン問題

from intersectionLib import *
from approximateCircuit import *
from drawTSP import *
from setRandomXY import *
from setCity4 import *
from exchangePoint import *
import random,math,time
NX=10;NY=10     # XY方向都市数
NUMCITY=NX*NY   # 都市数
CHAREA1=1.5     # チェック範囲辺サイズ比率(交換チェック用)
CHAREA2=1.8     # チェック範囲辺サイズ比率(隣接2点移動用)
CHMIN  =  2     # 最低チェック範囲
stopFlag=False  # 停止フラグ
dFlag=False     # 途中経過描画フラグ
setType=1       # 座標設定 0: 乱数，1:整列
drawNoFlag=True # 表示時の番号表示
setCityMethod=0 # ルート組込み 0: 外側から, 1:内側から
Debug=False     # デバッグ・モード(現在未使用, 必要に応じて使用)
exeMode=True    # 1点挿入時の処理モード（現在Trueに固定)
flag2Point=False# 2点挿入を実行するかどうかのフラグ
def shiftExec(XX, i1,i2,shiftMode=True):
    V1=lenVisit(XX)
    X1=XX[i1];X2=XX[i2]; XX[i1]=X2;XX[i2]=X1
    V2=lenVisit(XX);iflag=True; noShift=False
    if shiftMode:
        if abs(V1-V2)>0.0000001 and V2>V1:noShift=True
    else:
        if abs(V1-V2)>0.0000001 or V2>V1:noShift=True
    if noShift: XX[i1]=X1;XX[i2]=X2 # 元に戻す
    else:print("シフト実行 ",X1[2], X2[2])
    return XX
def shiftExchange(XX,drawNoFlag):#■順序入れ替えによる改善
    global root, canvas,stopFlag,dFlag
    N=len(XX);drawCityOnly(canvas, XX,drawNoFlag)
    drawState(canvas, "順序入れ替え中"); root.update()
    for i in range(N):
        i1=ptC(N,i+1);i2=ptC(N,i+2)
        #if dFlag:draw2Point(canvas, XX[i1],XX[i2]);root.update()
        XX= shiftExec(XX,i1,i2)
        if dFlag:
            drawCityOnly(canvas, XX,drawNoFlag)
            draw2Point(canvas, XX[i1],XX[i2]);root.update()
            drawState(canvas, "順序入れ替え中"); root.update()
    return XX
def deleteIntersection(XX,drawNoFlag):#■交差による距離改善
    global canvas,root, stopFlag, dFlag
    drawCityOnly(canvas, XX,drawNoFlag)
    drawState(canvas, "交差チェック中"); root.update()
    N=len(XX);NN=N-1; iflag=0;NX=copyLL(XX); DZ=lenVisit(XX)
    iflag=False
    for i in range(N):
        i1=i; i2=i+1;A=XX[ptC(N,i1)];B=XX[ptC(N,i2)];ID=-1
        for j in range(i2+1,i2+NN-3):
            C=XX[ptC(N,j)];D=XX[ptC(N,j+1)]
            ch=checkIntersect(XX[ptC(N,i1)],XX[ptC(N,i2)],
                              XX[ptC(N,j)],XX[ptC(N,j+1)])
            if ch:ID=j;break
        if ID>=0:
            iflag+=1
            print("交差点検出")
            print("線分　AB ",strXYP(A),"," ,strXYP(B))
            print("線分　CD ",strXYP(C),"," ,strXYP(D))
            draw2Point(canvas, A,B)
            draw2Point(canvas, C,D)
            root.update()
            LL=int((i2+ID+1)/2+0.000001-i1)#逆順交換用繰返し回数
            for j in range(LL+1):# 交差点の後を逆順にする
                ij=ptC(N,i2+j);ik=ptC(N,ID-j)
                NX[ij]=copyList(XX[ik])
                NX[ik]=copyList(XX[ij])
            DZ=lenVisit(NX); XX=copyLL(NX)
            print("交差検出による入れ替え　%8.4f"%(DZ))
            drawCityOnly(canvas, XX,drawNoFlag)
            root.update()
    return [iflag,XX]
def insertPoint2(XX, drawNoFlag,
                 CHAREA1,CHMIN,tryMode=False):#近辺2都市の入換え
    global canvas,root, stopFlag, dFlag
    drawCityOnly(canvas, XX,drawNoFlag)
    drawState(canvas, "2点挿入チェック中"); root.update()
    N=len(XX); DZ=lenVisit(XX); iflag=0
    for i in range(N):#P1とP2の間に挿入
        if stopFlag:break
        P1=copyList(XX[i]);i2=ptC(N,i+1);P2=copyList(XX[i2])
        R=nearPoint(XX,P1,P2,CHMIN, CHAREA1)
        if R!=[]:
            P3=R[0];RR=R[1]
            try:
                R=nearPoint(RR,P2,P1,CHMIN, CHAREA1);P4=R[0];RR=R[1]
                if R!=[]:
                    if dFlag:
                        drawCityOnly(canvas, XX,drawNoFlag)
                        drawPoint(canvas, P1)
                        drawState(canvas, "2点挿入チェック中")
                        root.update()
                    NX1=insert2Point(RR,P1,P3,P4);DM1=lenVisit(NX1)
                    NX2=insert2Point(RR,P1,P4,P3);DM2=lenVisit(NX2)
                    if DM1<=DM2: DM=DM1;NX=NX1# P3,P4の順を採用
                    else:        DM=DM2;NX=NX2# P4,P3の順を採用
                    if DM<=DZ or (tryMode and abs(DM-DZ)<0.00001):
                        if DM==DM1:printExchange1(DM,DZ,P1,P3,P4)
                        else      :printExchange1(DM,DZ,P1,P4,P3)
                        DZ=DM; XX=copyLL(NX);iflag+=1
            except:
                print("内部エラー")
                break
    drawCityOnly(canvas, XX,drawNoFlag);root.update()
    return [iflag, XX]      
def replaceNearest2(XX, drawNoFlag,
                    CHAREA1,CHMIN,tryMode=False):#近燐2点交換
    global canvas,root, stopFlag, dFlag
    drawCityOnly(canvas, XX,drawNoFlag)
    drawState(canvas, "辺挿入チェック中"); root.update()
    N=len(XX); DZ=lenVisit(XX); iflag=0
    for i1 in range(N-1):#P1とP2の間に挿入
        if stopFlag:break
        P1=copyList(XX[i1]);i2=ptC(N,i1+1);P2=copyList(XX[i2])
        R0=setDist(P1,P2)*CHAREA1
        if R0<CHMIN:R0=CHMIN #短いとき一定距離とする
        for j in range(4,N-4): # 挿入対象都市をP3, P4とする
            j1=ptC(N,i1+j);j2=ptC(N,i1+j+1)
            P3=copyList(XX[j1]); P4=copyList(XX[j2])
            # 距離　R13:P1とP3,R14:P1とP4,R23:P2とP3,R24:P2とP4
            R13=setDist(P1,P3); R14=setDist(P1,P4)
            R23=setDist(P2,P3); R24=setDist(P2,P4)
            BT=copyList(XX)
            if (R13<R0 or R14<R0 or R23<R0 or R24<R0):#近傍のとき
                if dFlag:
                    drawCityOnly(canvas, XX,drawNoFlag)
                    drawPoint(canvas, P1);drawPoint(canvas, P2)
                    drawState(canvas, "辺挿入チェック中")
                    root.update()

                NX1=replace2Point(XX,P1,P2,P3,P4);DM1=lenVisit(NX1)
                NX2=replace2Point(XX,P1,P2,P4,P3);DM2=lenVisit(NX2)
                if DM1<=DM2: DM=DM1;NX=NX1# P3,P4の順を採用
                else:        DM=DM2;NX=NX2# P4,P3の順を採用     
                if DM<DZ or (tryMode and abs(DM-DZ)<0.00001):
                    # 入換え(P1,P3,P4,P2) or (P1,P4,P3,P2)
                    if DM==DM1:printExchange2(DM,DZ,P1,P2,P3,P4)
                    else      :printExchange2(DM,DZ,P1,P2,P4,P3)
                    DZ=DM; XX=copyLL(NX);iflag+=1
                    if dFlag:
                        drawCityOnly(canvas, XX,drawNoFlag)
                        root.update()
    drawCityOnly(canvas, XX,drawNoFlag);root.update()
    return [iflag, XX]      
def exeTry(XX,exeMode, drawNoFlag, CHAREA1,CHMIN,tryMode=False):
    global canvas,root, stopFlag, dFlag         #■1点挿入による試行
    drawCityOnly(canvas, XX,drawNoFlag)
    drawState(canvas, "1点挿入チェック中"); root.update()

    N=len(XX);NN=N-1;iflag=0;DZ=lenVisit(XX)
    BT=copyList(XX)
    for i in range(N):
        if stopFlag:break
        i2=ptC(N,i+1); R0=setDist(XX[i],XX[i2])*CHAREA1
        if R0<CHMIN:R0=CHMIN #短いとき一定距離とする
        for j in range(N):
            if j!=i and j!=i2:
                RX=setDist(XX[i],XX[j])
                if RX<=R0:
                    LL=exchangeList(XX,i,j)#点位置交換
                    if dFlag:
                        drawCityOnly(canvas, LL,drawNoFlag)
                        drawPoint(canvas, XX[i]);drawPoint(canvas, XX[i2])
                        drawState(canvas, "1点挿入チェック中");root.update()
                    DM=lenVisit(LL)
                    if DM<DZ or (tryMode and abs(DM-DZ)<0.00001):
                        printExchange(DM,DZ,XX[i],XX[j])
                        DZ=DM; XX=LL;iflag+=1
                        if exeMode: break
        if exeMode and iflag:break
    drawCityOnly(canvas, XX,drawNoFlag);root.update()
    return [iflag,XX]
def near2PointMove(XX,drawNoFlag,CHAREA2):#■隣接2点移動による距離短縮
    global canvas,root, stopFlag, dFlag
    drawCityOnly(canvas, XX,drawNoFlag)
    drawState(canvas, "隣接2点チェック中"); root.update()
    N=len(XX);NN=N-1;iflag=0;DZ=lenVisit(XX)
    for i1 in range(N):#隣接2点の移動による改良
        if stopFlag:break
        i2=ptC(N,i1+1)
        RR=get2Point(XX,i1,i2);Xi=RR[0];Xj=RR[1];R=RR[2]
        if dFlag:
            drawCityOnly(canvas, R,drawNoFlag)
            draw2Point(canvas, Xi,Xj)
            drawState(canvas, "隣接2点チェック中")
            root.update()
        DRR=setDist(Xi,Xj)*CHAREA2
        for i in range(NN-3):
            DR1=setDist(Xi,R[i])
            if DR1<=DRR:
                for j in range(NN-2):
                    if i!=j:
                        DR2=setDist(Xj,R[j])
                        if DR2<=DRR:
                            XR=set2Point(R,Xi,Xj,i,j)
                            DM=lenVisit(XR)
                            if abs(DM-DZ)<0.000001 or DM<DZ:
                                print2Move(Xi,Xj,DZ,DM)
                                DZ=DM; XX=XR;iflag+=1
                            XR=set2Point(R,Xj,Xi,i,j)
                            DM=lenVisit(XR)
                            if abs(DM-DZ)<0.000001 or DM<DZ:
                                print2Move(Xi,Xj,DZ,DM)
                                DZ=DM; XX=XR;iflag+=1
    drawCityOnly(canvas, XX,drawNoFlag);root.update()
    return [iflag,XX]
def try2(XX,exeMode,drawNoFlag, #■立寄りによる改善2
         CHAREA1,CHAREA2,CHMIN):
    global canvas,root, stopFlag, dFlag 
    N=len(XX);DZ=lenVisit(XX);NN=N-1;Nupd=1;NDTlist=[]
    print("手法２による巡回路変更")
    #XX=inverseRoot(XX) #順序を逆転する場合，注釈を外す
    while Nupd>0:# 点交換による距離短縮
        Nupd=0;XB=copyLL(XX)
        XX=intersection(XX,drawNoFlag)
        R=near2PointMove(XX,drawNoFlag,CHAREA2)# 隣接2点移動
        XX=R[1];Nupd=R[0]#; Nupd+=R[0] #終了判定にこの結果を使わない。
        print("**隣接2点移動: 点移動回数=", R[0])
        NDTlist.append([R[0]])
        if stopFlag:break
        if XX==XB: break
    for i in range(10):
        if Nupd==0: break;
        if stopFlag:break
        XX=intersection(XX,drawNoFlag)
        Nupd=0;NDT=[0,0]
        R=exeTry(XX,exeMode,drawNoFlag,CHAREA1,CHMIN) #1点挿入
        XX=R[1];NDT[1]=R[0];Nupd+=R[0]
        print("**1点挿入: 点移動回数=", R[0])
        if Nupd!=0:
            R=near2PointMove(XX,drawNoFlag,CHAREA2)# 隣接2点移動
            XX=R[1];NDT[0]=R[0]#; Nupd+=R[0] #終了判定にこの結果を使わない。
            print("**隣接2点移動: 点移動回数=", R[0])
            NDTlist.append(NDT)
    return [NDTlist, XX]
def try1(XX,flag2Point,exeMode,drawNoFlag, #■立寄りによる改善
         CHAREA1,CHAREA2,CHMIN):
    global canvas,root, stopFlag, dFlag 
    N=len(XX);DZ=lenVisit(XX);NN=N-1;Nupd=1;NDTlist=[];k=0
    print("都市入替えによる巡回路変更")
    while Nupd>0:# 点交換による距離短縮
        Nupd=0;NDT=[0,0,0,0];k+=1
        drawCityOnly(canvas, XX,drawNoFlag)
        XX=shiftExchange(XX,drawNoFlag)
        if k>4: break
        if stopFlag:break
        if flag2Point:
            R=insertPoint2(XX,drawNoFlag,CHAREA1,CHMIN)#2点挿入
            XX=R[1];NDT[0]=R[0]
        if stopFlag:break
        R=near2PointMove(XX,drawNoFlag,CHAREA2)# 隣接2点移動
        XX=R[1];NDT[1]+=R[0]#; Nupd+=R[0] #終了判定にこの結果を使わない。
        print("**隣接2点移動: 点移動回数=", R[0])
        TR=True
        #if k%2==0:TR=False
        if stopFlag:break
        R=exeTry(XX,exeMode,drawNoFlag,CHAREA1,CHMIN,tryMode=TR) #1点挿入
        XX=R[1];NDT[2]=R[0];Nupd+=R[0]
        print("**1点挿入: 点移動回数=", R[0])
        if stopFlag:break
        R=replaceNearest2(XX, drawNoFlag,CHAREA1,CHMIN)#辺挿入
        XX=R[1];NDT[3]=R[0]; Nupd+=R[0]
        print("**辺挿入: 点移動回数=", R[0])
        NDTlist.append(NDT)
        if stopFlag:break
    return [NDTlist,XX]
def intersection(XX,drawNoFlag):
    fl=True;XX=shiftExchange(XX,drawNoFlag)
    while fl:
        R=deleteIntersection(XX,drawNoFlag);XX=R[1]; fl=R[0]
        if fl:XX=shiftExchange(XX,drawNoFlag)
    return XX
def try0(XX,flag2Point,exeMode,drawNoFlag, #■立寄りによる改善
         CHAREA1,CHAREA2,CHMIN):
    XX=intersection(XX,drawNoFlag)
    IR1=0;IR2=0;IR3=0 #中途停止のための安全処理
    if flag2Point and (not stopFlag):
        R=insertPoint2(XX,drawNoFlag,CHAREA1,CHMIN)#2点挿入
        XX=R[1];IR3=R[0]
    if not stopFlag:
        R=replaceNearest2(XX,drawNoFlag,CHAREA1,CHMIN)#近隣2点交換
        XX=R[1];IR1=R[0]
    if not stopFlag:
        R=exeTry(XX,exeMode,drawNoFlag,CHAREA1,CHMIN)#1点挿入
        XX=R[1];IR2=R[0]
    if not stopFlag:XX=intersection(XX,drawNoFlag)
    return[[IR1,IR2,IR3],XX]
def drawResult(canvas,NUMCITY,XX,DST0,DZ):
    P=(DST0-DZ)/DZ
    S=("都市数 %d, 巡回路長 %8.4f 初期値 %8.4f 改善率 %8.4f" %
       (NUMCITY, DZ,DST0,P))
    drawState(canvas, S)
def leftMouseDown(event):
    global stopFlag
    stopFlag=True
#--------------(メイン・プログラム)----------------
root=Tk(); root.title("辺近傍法によるTSP(終わらせるときは左クリック)")
canvas=Canvas(root,width=640, height=640,bg="white")
canvas.pack();root.update()
canvas.bind("<Button-1>",leftMouseDown)
while True:
    #------ユーザ指定入力 :  #終了は[Cancel]ボタン
    tmp=inpAsk(setType)      # 設定方法の指定乱数による座標設定(0),
    if tmp==None:break       # 　(0) 乱数による座標設定
    setType=int(tmp)         #   (1) 整列した座標設定
    tmp=inpNumCity(NX,NY)    # 都市数の指定
    if tmp==None:break
    NX=tmp[0];NY=tmp[1]; NUMCITY=NX*NY
    tmp=inpAsk(setCityMethod,title="巡回路設定方向",
               message= "[Cancel]:終了, 0:外側から，1:内側から")
    if tmp==None:break
    setCityMethod=int(tmp)
    tmp=inpAsk(0,title="2点挿入実行",
               message= "[Cancel]:終了, 0:しない，1:する")
    if tmp==None:break
    if tmp=="0": flag2Point=False # 2点挿入を実行するかどうか
    else:flag2Point=True
    tmp=inpAsk(0,title="途中経過表示",
               message= "[Cancel]:終了, 0:しない，1:する")
    if tmp==None:break
    if tmp=="0": dFlag=False # 途中経過を表示するか
    else:dFlag=True
    #------初期座標設定-------------------------------
    #random.seed(33220)        # 乱数値固定用
    cityXY=setCityXY(NX,NY,setType) # 都市座標設定
    MM=setMinMax(cityXY)      # 座標値の最小と最大を求める
    #------初期４都市設定------------------------------
    if setCityMethod==1: XX=startSquare2(cityXY,MM)
    else: XX=startSquare(cityXY,MM) # 最初の四角形を作成する
    #------その他の都市を巡回路に挿入------------------
    XX=inseartCity(root, canvas, XX,MM, setCityMethod, cityXY, drawNoFlag)
    if setType==0: XX=exchangeNo(XX)
    DST0=lenVisit(XX)
    #------交差による検査と距離短縮(交差部分の順序入れ替え)---
    while True:
        stopFlag=False
        #------点移動による距離短縮---
        NDTlist=[]
        R=try0(XX,flag2Point,exeMode,drawNoFlag,CHAREA1,CHAREA2,CHMIN)
        IR1=R[0][0];IR2=R[0][1];IR3=R[0][1];XX=R[1]
        #------都市入替えによる距離短縮---------------------
        if not stopFlag:
            R=try1(XX,flag2Point,exeMode,drawNoFlag,CHAREA1,CHAREA2,CHMIN)
            NDTlist=R[0];XX=R[1]
        #------この時点の処理結果を近似解とみなす----------
        drawCityOnly(canvas, XX,drawNoFlag); DZ=lenVisit(XX)
        DZ=lenVisit(XX);drawResult(canvas,NUMCITY,XX,DST0,DZ)
        print("移動[0,", IR3,",", IR1, ", ", IR2,"]", NDTlist)
        ret = messagebox.askyesno('確認', '再スキャンしますか')
        if not ret:break
        ret = messagebox.askyesno('確認', '補助試行モードを適用しますか')
        if ret:
            print("手法２")
            stopFlag=False; DST0=DZ
            R=try2(XX,exeMode,drawNoFlag,CHAREA1,CHAREA2,CHMIN)
            NDTlist=R[0];XX=R[1]
            DZ=lenVisit(XX); drawResult(canvas,NUMCITY,XX,DST0,DZ)
            print("補助試行モード",R[0])
            ret = messagebox.askyesno('補助試行モード完了', '再スキャンしますか')
            if not ret:break
        


        

        
